$INTERFACE U0SSU2                                             97/12/01
$REM LU
  $N='NF'
  $ADD(REAL,'\$AFO($NA)')
  $ADD(INTEGER,'\IMD\LDS\METS')
  $JARA='L'
  $GN=G
  $D=XS
  $DL=GS
  $DU=XP
  $DU2=GP
  $AGS=AG
  $AGH='AGH'
  $IF(CONSTR='S')
    $CONSTR='C'
    $ADD(REAL,'\UXUDOT')
  $ELSE
    $ADD(REAL,'\UXVDOT')
  $ENDIF
  $LU=0
  $HELP
    TYPE OF METHOD:
      L - LINE SEARCH
      G - GENERAL TRUST REGION
  $CHECK(TYPE,'G','L\G',2,NO)
  $IF(NA=NF)
    $HELP
      MATRIX DECOMPOSITION:
        A - RECTANGULAR MATRIX
        E - GENERAL MATRIX FOR NONLINEAR EQUATIONS
        I - INVERSION OF A TRIDIAGONAL MATRIX FOR NONLINEAR
            EQUATIONS
    $CHECK(DECOMP,'E','A\E\I',2,NO)
  $ELSE
    $DECOMP='A'
  $ENDIF
  $IF(DECOMP='I')
    $IF(TYPE='L')
      $HELP
        METHOD
          1 - SPARSE LU FACTORIZATION
          3 - INCOMPLETE LU FACTORIZATION WITH
              SMOOTHED CGS ITERATIONS AFTER RESTART
      $CHECK(NUMBER,3,'1\3',2,NO)
      $IF(NUMBER>1) $LU=1
    $ELSE
      $NUMBER=1
    $ENDIF
  $ELSEIF(DECOMP='A')
    $HELP
       METHOD
         3 - INEXACT SOLUTION BY CGLS METHOD
         4 - INEXACT SOLUTION BY LSQR METHOD
    $CHECK(NUMBER,3,'3\4',2,NO)
  $ELSE
    $HELP
       METHOD
         3 - INEXACT SOLUTION BY SMOOTHED CGS METHOD
         4 - INEXACT SOLUTION BY RESTARTED GMRES METHOD
         5 - INEXACT SOLUTION BY SMOOTHED BICGSTAB METHOD
    $CHECK(NUMBER,3,'\3\4\5',2,NO)
    $HELP
      PRECONDITIONING TECHNIQUE
        ABS(MOS2)=0 - PRECONDITIONING IS SUPPRESSED
        ABS(MOS2)=1 - INCOMPLETE LU PRECONDITIONING
        ABS(MOS2)=2 - SSOR PRECONDITIONING
           MOS2 < 0 - PRECONDITIONED ITERATIVE PROCESS
           MOS2 > 0 - PRELIMINARY INEXACT SOLUTION FOLLOWED
                      BY PRECONDITIONED ITERATIVE PROCESS
    $CHECK(MOS2,1,'-2\-1\0\1\2',1)
    $IF(MOS2<>0) $LU=1
  $ENDIF
  $IF(TYPE='L')
    $KDS=0
    $HELP
      LINE SEARCH INTERPOLATION
        1 - BISECTION
        2 - TWO POINT QUADRATIC INTERPOLATION
        3 - THREE POINT QUADRATIC INTERPOLATION
        4 - THREE POINT CUBIC INTERPOLATION
        5 - SPECIAL BIQUADRATIC INTERPOLATION
    $CHECK(MES,1,'1\2\3\4\5',3)
    $STEP=1
    $IF(MES=5) $STEP=4
    $DEFAULT=-2
    $IF(NA=NF) $DEFAULT=1
    $HELP
      CHOICE OF THE INITIAL STEPSIZE:
                0 - INITIAL STEPSIZE IS SPECIFIED IN THE CALLING PROGRAM
          -1 OR 1 - UNIT INITIAL STEPSIZE
          -2 OR 2 - COMBINED UNIT AND QUADRATICALLY ESTIMATED INITIAL
                    STEPSIZE (DAVIDON)
          -3 OR 3 - COMBINED UNIT AND QUADRATICALLY ESTIMATED INITIAL
                    STEPSIZE (STOREY )
          -4 OR 4 - QUADRATICALLY ESTIMATED INITIAL STEPSIZE
        INITS < 0 - THE PREVIOUS FUNCTION VALUE IS USED
        INITS > 0 - THE MINIMUM  FUNCTION VALUE IS USED
    $CHECK(INITS,DEFAULT,'-4\-3\-2\-1\1\2\3\4',4)
    $HELP
      CONTROLLING OF THE INITIAL STEPSIZE:
        0-NO CONTROLLING OF THE INITIAL STEPSIZE
        1-CONTROLLING BASED ON THE FUNCTION DECREASE
        2-CONTROLLING BASED ON THE DIRECTION VECTOR
        3-CONTROLLING BASED ON THE NUMBER OF FUNCTIONS
    $CHECK(ISTEP,0,'0\1\2\3',4)
    $HELP
      TOLERANCE FOR DESCENT DIRECTION
    $CHECK(EPS0,ETA0,REAL,4)
    $HELP
      LOWER BOUND FOR STEPSIZE PARAMETER
    $CHECK(ALF1,'1.0$P-15',REAL,4)
  $ELSE
    $HELP
      MAXIMUM NUMBER OF ZERO STEPS IN ONE ITERATION
    $CHECK(MRED,5,INT,4)
    $ISTEP=0
    $HELP
      LINE SEARCH
        1 - FOR MINIMIZATION
        2 - FOR NONLINEAR EQUATIONS
    $CHECK(STEP,1,'1\2',4,NO)
    $HELP
      DECISION AFTER ZERO STEP
        0 - NEW DIRECTION DETERMINATION
        1 - CONTINUATION OF THE ITERATION
    $CHECK(MOT3,0,'0\1',4)
  $ENDIF
  $HELP
    COMPUTATION OF DERIVATIVES
      1 - DERIVATIVES OF THE APPROXIMATING FUNCTIONS
          ARE COMPUTED
      2 - COLEMAN-MORE GRAPH COLORING ALGORITHM IS USED
  $CHECK(NUMDER,1,'1\2',4,NO)
  $IF(DECOMP='I')
    $HELP
      TYPE OF UPDATE
        B - INVERSE COLUMN UPDATE
        N - NO UPDATE
    $CHECK(UPDATE,'B','B\NO\N',3,NO)
    $IF(UPDATE='N') $UPDATE='NO'
    $IPOM2=0
    $IF(UPDATE='B') $IPOM2=1
  $ELSE
    $HELP
      TYPE OF UPDATE
        B - THE LIMITED MEMORY BROYDEN UPDATE
        N - NO UPDATE
    $CHECK(UPDATE,'N','B\NO\N',3,NO)
    $IF(UPDATE='N') $UPDATE='NO'
    $IPOM2=0
    $IF(UPDATE='B') $IPOM2=1
  $ENDIF
  $UPD=UPDATE
  $IF(UPD='B')
    $HELP
      MAXIMUM NUMBER OF ZERO STEPS IN ONE ITERATION
    $CHECK(MRED,10,INT,4)
    $IF(DECOMP='I') $UPD='C'
  $ENDIF
  $ISNF=0
  $ISNA=3
  $ADD(INIT)
    ISNA=3
  $ENDADD
  NDECF=0
  IPOM2=$IPOM2
  $SUBST('UO0FU1')
  $SUBST('UZLIND')
  $MAL=NA
   MAL=NA
  $JOB=1
  $IF(NORMA>0) $SUBST('UANRL1')
  $IF(NORMF>0) $SUBST('UATRL1')
  $IF(NCL>0)
    $MCL=NCL
     MCL=NCL
    $ISNC=3
    $ADD(INIT)
      ISNC=3
    $ENDADD
    $JOB=1
    $IF(NORMC>0) $SUBST('UCNRL1')
    $IF(NORMF>0) $SUBST('UCTRL1')
    $SUBST('UCLNF2')
  $ENDIF
  $IF(CONSTR='C') $SUBST('UYFPC1')
  $IF(LU=1) $SUBST('UYGISJ')
  $IF(NUMDER=2) $SUBST('UYCMSA')
*
*     ----------------------------------
*     LIMITED MEMORY QUASI-NEWTON METHOD
*     TEMPLATE : U0SSU2
*     ----------------------------------
*
  $LMD=$10
  $LMS=$35
  ASSIGN $20 TO IMD
  CALL UYPRO1('UXFU',0)
  CALL UYPRO3(1)
  MOT=0
  T=ZERO
  FO=FMIN
  IPOM1=0
  METS=MET
$L=$10 ; $LABEL
  $KD=0
  $SUBST('UZMODL')
  GO TO IMD
$L=$20 ; $LABEL
  N=NF
  $SUBST('UO2FU3')
  $SUBST('UYFUT1')
  IF (ITERM.NE.0) GOTO $95
  $IF(CONSTR='C') $SUBST('UYRM$(CONSTR)0')
  $IF(ISTEP=2)
    DMAX=R*SNORM
  $ENDIF
$L=$30 ; $LABEL
  $IF(UPDATE<>'NO')
    MRED=$MRED
    IF (IREST.LE.0) MRED=5
  $ENDIF
  $IF(NUMDER=1)
    $SUBST('UUDRD1')
  $ELSE
    $SUBST('UUSRD2')
    $GO TO $40
$L=$35 ; $LABEL
    ASSIGN $35 TO IMD
    $SUBST('UA0JS3')
    GOTO ($36,$10) ISB+1
$L=$36 ; $LABEL
    GO TO IMS
  $ENDIF
$L=$40 ; $LABEL
  IF(ITERM.NE.0) GOTO $95
  $IF(CONSTR='C') CALL UXVINB(NF,MA,$IX,$JAG)
  $MAT='G'
  $IF(DECOMP='I') $MAT='L'
  $DEC=DECOMP
*
*     -----------------------
*     DIRECTION DETERMINATION
*     TEMPLATE : UD$(MAT)$(TYPE)$(DECOMP)$(NUMBER)
*     -----------------------
*
  $SUBST('UD$(MAT)$(TYPE)$(DECOMP)$(NUMBER)')
*
*     ------------------------------
*     END OF DIRECTION DETERMINATION
*     ------------------------------
*
  $IF(DECOMP='A')
    P=UXVDOT(N,S,G)
    $ADD(REAL,'\UXVDOT')
  $ENDIF
  $SUBST('UD1T$(TYPE)1')
$REM  $IF(CONSTR='C') CALL UXVINE(MA,$JAG)
  IF(ITERM.NE.0) GOTO $95
  IF(IREST.NE.0) GOTO $30
  LDS=LD
$L=$50 ; $LABEL
  $IF(ISTEP>0)
    CALL UYSET4(NF,NA,INITS,ISTEP,F,FO,SNORM,DMAX)
  $ENDIF
  $SUBST('UYTR$(CONSTR)S')
  $IF(CONSTR='C')
    IF (RMAX.EQ.ZERO) GO TO $75
  $ENDIF
  CALL UXVCOP(NA,$AF,$AFO)
$L=$60 ; $LABEL
  ASSIGN $60 TO IMD
  $SUBST('UZLINS')
  GOTO ($70,$65) ISB+1
$L=$ 65 ; $LABEL
  $IF(CONSTR='C')
    CALL UXUDIR(NF,R,$S,$XO,$X,$IX,KBF)
    $SUBST('UCBS04')
  $ELSE
    CALL UXVDIR(NF,R,$S,$XO,$X)
  $ENDIF
  GOTO $10
$L=$ 70 ; $LABEL
  IF (ITERS.LE.0) THEN
  $SUBST('UYZER0')
  $IF(TYPE='L')
    CALL UXVCOP(NA,$AFO,$AF)
  $ELSE
    IF (MOT3.LE.0) CALL UXVCOP(NA,$AFO,$AF)
  $ENDIF
  IF(IDIR.EQ.0) THEN
  CALL UYRES1(TSXX)
  LD=LDS
  GO TO $30
  ELSE IF (MOT3.EQ.0) THEN
  LD=LDS
  GO TO $30
  ELSE
  ITERD=0
  ENDIF
  ENDIF
  IF (IPOM2.GT.0) THEN
  $SUBST('UUDRV1')
  ENDIF
  IF (IPOM1.EQ.1) KD=1
  IF(KD.GT.LD) THEN
  ASSIGN $80 TO IMD
  GO TO $10
  ENDIF
$L=$80 ; $LABEL
  KD=0
  TXFU = TUXX
  $IF(UPDATE<>'NO')
$REM    $IF(CONSTR='C') CALL UXVINB(NF,MA,$IX,$JAG)
    $IHLP=1
  $ENDIF
  $IF(UPD='B')
    IF(IPOM1.EQ.2) THEN
      $SUBST('UYTR$(CONSTR)F')
      $SUBST('UULBA$(IHLP)')
    ELSE
      $SUBST('UYTRUD')
    ENDIF
  $ELSEIF(UPD='C')
    IF(IPOM1.EQ.2) THEN
      $SUBST('UYTR$(CONSTR)F')
      $SUBST('UULCI$(NUMBER)')
    ELSE
      $SUBST('UYTRUD')
    ENDIF
  $ELSE
    IREST=1
    $SUBST('UYTRUD')
  $ENDIF
$L=$75 ; $LABEL
  MET=METS
  IF(IDIR.EQ.0) THEN
  IF(ITERH.NE.0) CALL UYRES1('UPDATE  ')
  $IF(CONSTR='C') $SUBST('UYADC0')
  GOTO $20
  ELSE
  GOTO $30
  ENDIF
$L=$95 ; $LABEL
  IF(ITERM.LT.0) TXFU=TDXX
  CALL UYEPI1(0)
  $IF(NAL>0)
    $JOB=-1
    $IF(NORMA>0) $SUBST('UANRL1')
  $ENDIF
  $IF(NCL>0)
    $JOB=-1
    $IF(NORMF>0) $SUBST('UCTRL1')
    $IF(NORMC>0) $SUBST('UCNRL1')
  $ENDIF
  $SUBST('UO1FU2')
  $ADD(INIT)
    NXFU='U0SSU2'
  $ENDADD
  $EXIT
