$INTERFACE U1ASE1                                             16/12/01
$REM LU
  $OPTION(LPERFD=.TRUE.)
  $GF='GF'
  $ADD(INTEGER,'\NFO\NCO\MCO\IMS\J\K\L')
  $ADD(INTEGER,'\$IAG($NA+1)\$JAG($MA)')
  $HELP
    REPRESENTATION OF THE ADDITIONAL VARIABLES
      0 - LINEAR
      1 - NONLINEAR
  $CHECK(MEP5,0,'0\1',2)
  $IF(NC=0)
    $MC=0
    $MCH=0
    $KDC=KDA
    $KBC=1
    $IF(KBF=0)
      $KBF=1
      $XL='XL'
      $XU='XL'
    $ENDIF
    $CU=CL
    $FMODC='X'
    $GMODC='X'
    $IF($DEF(FMODELA))
      $SET(FMODELC)
*       NEW FMODELC
      $ENDSET
      $FMODC='F'
    $ENDIF
    $IF($DEF(GMODELA))
      $SET(GMODELC)
*       NEW GMODELC
      $ENDSET
      $GMODC='G'
    $ENDIF
    $IF($DEF(FGMODELA))
      $SET(FGMODELC)
*       NEW FGMODELC
      $ENDSET
      $FMODC='FG'
    $ENDIF
    $CRED='NO'
    $MODELC='YES'
    $LDC=-1
$REM    $SUBST('UZMODC')
  $ENDIF
  $HELP
    METHODS FOR SOLVING RESULTING NONLINEAR PROGRAMMING PROBLEM
      I - INTERIOR POINT METHODS
      F - NONSMOTH EQUATION METHODS
  $CHECK(DECOMP,'I','I\F',2,NO)
  KBC=$KBC
  KBF=$KBF
  $NFO=NF
  $NXO=NX
  $NCO=NC
  $MCO=MC
  $ADD(SINIT)
    CALL UXVINS(NF,0,$IX)
    CALL UXVINP(NF+2*NA+1,$IH)
    CALL UXVINP(NF+2*NA,$JH)
  $ENDADD
  $ADD(SINID)
*
*     -----------------------------
*     TRANSORMATION OF L1 NORM TO A
*     EQUALITY CONSTRAINED PROBLEM
*     TEMPLATE : U1ASE1
*     -----------------------------
*
    IF (NC.EQ.0) MC=0
    NFO=NF
    NCO=NC
    MCO=MC
    CALL UXVSET(2*NA,0.0$P 0,$X(NF+1))
    CALL UXVSET(2*NA,0.0$P 0,$XL(NF+1))
    CALL UXVINS(2*NA,1,$IX(NF+1))
    NF=NF+2*NA
    NX=NF
    CALL UXVINS(NA,5,$IC(NC+1))
    CALL UXVSET(NA,ZERO,$CL(NC+1))
    CALL UXVICP(MA,$JAG,$JCG(MC+1))
    DO $10 KA=1,NA+1
    $ICG(NC+KA)=MC+$IAG(KA)
$10 CONTINUE
    MC=NF
    DO $30 KC=NA,1,-1
    K=$ICG(KC+NC)
    L=$ICG(KC+NC+1)-1
    DO $20 J=L,K,-1
    $JCG(J+2*(KC-1))=$JCG(J)
$20 CONTINUE
    $JCG(L+2*KC-1)=MC-NA
    $JCG(L+2*KC)=MC
    $ICG(KC+NC+1)=$ICG(KC+NC+1)+2*KC
    MC=MC-1
$30 CONTINUE
    NC=NC+NA
    MC=$ICG(NC+1)-1
    MA=2*NA
    MAH=3*NA
$REM    CALL UXVINP(NA+1,IBG)
    IBG(1)=1
    $IF(MEP5=0)
      NAL=NA
      DO $45 KA=1,NA
      K=IBG(KA)
      IBG(KA+1)=K+2
      JBG(K)=NFO+KA
      JBG(K+1)=NFO+NA+KA
      $AG(K)=ONE
      $AG(K+1)=ONE
$45   CONTINUE
    $ELSE
      NAL=0
      DO $45 KA=1,NA
      K=IBG(KA)
      IBG(KA+1)=K+2
      JBG(K)=NFO+KA
      JBG(K+1)=NFO+NA+KA
$45   CONTINUE
    $ENDIF
    $SUBST('UFSET5')
  $ENDADD
  $IF($DEF(MCH))
    $IF($DEF(MAH))
      $MCH='$MCH+2*$MAH'
    $ENDIF
  $ENDIF
  $SUBST('UCSUM2')
  $NF='$NF+2*$NA'
  $NX=NF
  $NCP=NC
  $NC='$NC+$NA'
  $MC='$MC+$MA+2*$NA'
  $MA='2*$NA'
  $MAH='3*$NA'
  $IAGS=IAG
  $JAGS=JAG
  $IAG='IBG'
  $JAG='JBG'
  $JACA='S'
  $IF(MEP5=0)
    $NAL=NA
  $ELSE
    $NAL=0
    $SET(FMODELA)
      FA=X(NFO+KA)+X(NFO+NA+KA)
    $ENDSET
    $SET(GMODELA)
      GA(NFO+KA)=ONE
      GA(NFO+NA+KA)=ONE
    $ENDSET
    $KDA=1
  $ENDIF
  $MCOLS=NF
  $OPTION(LPERFD=.FALSE.)
  $SUBST('U1FS$(DECOMP)1')
  $NF=NFO
  $NX=NXO
  $NC=NCO
  $MC=MCO
  NF=NFO
  NC=NCO
  MC=MCO
  $IAG=IAGS
  $JAG=JAGS
  $ADD(INIT)
    NXFU='U1ASE1'
  $ENDADD
  $EXIT
