$INTERFACE U1FBU1                                             97/12/01
$REM LU
  $N='NF'
  $ADD(INTEGER,'\IMD')
  $HERF='B'
  $HELP
    MAXIMUM SIZE OF THE PARTITIONED HESSIAN MATRIX
  $CHECK(MAH,'25*$NA',INT,1)
  $IF(CONSTR='S')
    $CONSTR='C'
    $ADD(REAL,'\UXUDOT')
  $ELSE
    $ADD(REAL,'\UXVDOT')
  $ENDIF
  $HELP
    TYPE OF METHOD:
      L - LINE SEARCH
      G - TRUST REGION
  $CHECK(TYPE,'L','L\G',2,NO)
  $DECOMP='M'
  $NUMBER=3
  $IF(TYPE='G')
    $HELP
      CHOICE OF THE VARIABLE METRIC UPDATE AFTER ZERO STEP:
        0 - NO UPDATE
        1 - NORMAL UPDATE
    $CHECK(MOT3,0,'0\1',4)
  $ELSE
    $HELP
      CHOICE OF THE INITIAL STEPSIZE:
        1-UNIT INITIAL STEPSIZE
        2-COMBINED UNIT AND QUADRATICALLY ESTIMATED INITIAL
          STEPSIZE FOR VM METHODS
        3-COMBINED UNIT AND QUADRATICALLY ESTIMATED INITIAL
          STEPSIZE FOR CG METHODS
        4-QUADRATICALLY ESTIMATED INITIAL STEPSIZE
    $CHECK(INITS,2,'1\2\3\4',4)
  $ENDIF
  $HELP
    CHOICE OF THE INITIAL APPROXIMATION OF THE HESSIAN
    MATRIX:
      0 - INITIAL APPROXIMATION IS SPECIFIED IN THE CALLING
          PROGRAM
      1 - UNIT INITIAL APPROXIMATION
      2 - RANDOM INITIAL APPROXIMATION
      3 - NUMERICAL INITIAL APPROXIMATION
  $CHECK(INITH,1,'0\1\2\3',4)
  $UPDATE='B'
  $HELP
    TYPE OF UPDATE
      B - BROYDEN CLASS OF UPDATES
      P - THE POWELL SYMETRIC BROYDEN UPDATE
  $CHECK(UPDATE,'B','B\P',3,NO)
  $IF(UPDATE='B')
    $IF($DEF(MET3))
      $IF(MET3=3) $MET3=1
    $ENDIF
  $ELSE
    $MET=1
  $ENDIF
  $SUBST('UFSET2')
  $ISNA=2
  $ADD(INIT)
    ISNA=2
  $ENDADD
  $HELP
    CORRECTION OF APPROXIMATION OF HESSIAN MATRIX
    AFTER CHANGE OF BASIS:
      1 - RESTART
      2 - CORRECTION
  $CHECK(MLC,2,'1\2',3)
  $ISNA=2
  $ADD(INIT)
    ISNA=2
  $ENDADD
  $SUBST('UO0FU1')
  $SUBST('UZLIND')
  $IF(NAL>0)
    $MAL=NAL
     MAL=NAL
    $JOB=1
    $IF(NORMA>0) $SUBST('UANRL3')
  $ENDIF
  $IF(CONSTR='C') $SUBST('UYFPS1')
*
*     ----------------------------------
*     PARTITIONED VARIABLE METRIC METHOD
*     TEMPLATE : U1FBU1
*     ----------------------------------
*
  $LMD=$10
  ASSIGN $20 TO IMD
$L=$00 ; $LABEL
  CALL UYPRO1('UXFU',1)
  CALL UYPRO2(FMIN,FO)
$L=$10 ; $LABEL
  $KD=1 ; $IF(INITH=3) $KD=2
  $SUBST('UZMODL')
  $IF(KDS<1)
  $ELSEIF(CONSTR='C')
    IF(TSS(NS).EQ.'USXX') P=UXUDOT(NF,$G,$S,$IX,KBF)
  $ELSE
    IF(TSS(NS).EQ.'USXX') P=UXVDOT(NF,$G,$S)
  $ENDIF
  GO TO IMD
$L=$ 20 ; $LABEL
  $SUBST('UYTR$(CONSTR)G')
  $SUBST('UO2FU3')
  $SUBST('UYFUT1')
  IF (ITERM.NE.0) GOTO $90
  $IF(CONSTR='C') $SUBST('UYRM$(CONSTR)0')
$L=$ 30 ; $LABEL
  ASSIGN $30 TO IMD
  $SUBST('UUBSD1')
  GOTO ($40,$10) ISB+1
$L=$ 40 ; $LABEL
  IF (ITERM.NE.0) GOTO $90
  $IF(CONSTR='C') CALL UXVINB(NF,MA,$IX,$JAG)
  $SUBST('UYTB$(CONSTR)H')
  $DEC=DECOMP
  $MAT='G'
*
*     -----------------------
*     DIRECTION DETERMINATION
*     TEMPLATE : UD$(MAT)$(TYPE)$(DECOMP)$(NUMBER)
*     -----------------------
*
  $SUBST('UD$(MAT)$(TYPE)$(DECOMP)$(NUMBER)')
*
*     ------------------------------
*     END OF DIRECTION DETERMINATION
*     ------------------------------
*
  $SUBST('UD1T$(TYPE)1')
$REM  $IF(CONSTR='C') CALL UXVINE(MA,$JAG)
  IF (ITERM.NE.0) GOTO $90
  IF (IREST.NE.0) GOTO $30
$L=$ 50 ; $LABEL
  $SUBST('UYTR$(CONSTR)S')
  $IF(CONSTR='C')
    IF (RMAX.EQ.ZERO) GO TO $75
  $ENDIF
  CALL UXVCOP(MA,$AG,$AGO)
$L=$ 60 ; $LABEL
  ASSIGN $60 TO IMD
  $SUBST('UZLINS')
  GOTO ($64,$62) ISB+1
$L=$ 62 ; $LABEL
  $IF(CONSTR='C')
    CALL UXUDIR(NF,R,$S,$XO,$X,$IX,KBF)
  $ELSE
    CALL UXVDIR(NF,R,$S,$XO,$X)
  $ENDIF
  GOTO $10
$L=$ 64 ; $LABEL
  IF (ITERS.LE.0) THEN
  $IF(KDS<1)
    $SUBST('UYZER0')
  $ELSE
    $SUBST('UYZER1')
    CALL UXVCOP(MA,$AGO,$AG)
  $ENDIF
  IF(IDIR.EQ.0) THEN
  CALL UYRES1(TSXX)
  CALL UYSET1
  GO TO $30
  ELSE IF (MOT3.EQ.0) THEN
  CALL UYSET1
  GO TO $30
  ELSE
  ITERD=0
  ENDIF
  ENDIF
  IF(KD.GT.LD) THEN
  ASSIGN $80 TO IMD
  GO TO $10
  ENDIF
$L=$ 80 ; $LABEL
  TXFU=TUXX
  $IF(KDS>0)
    $HELP
      SELECTION OF SELF SCALING:
        1 - SELF SCALING SUPPRESSED
        2 - INITIAL SELF SCALING
        3 - CONTROLLED SELF SCALING
        4 - SELF SCALING IN EACH ITERATION
    $CHECK(MET1,3,'1\2\3\4',4)
  $ENDIF
$REM  $IF(CONSTR='C') CALL UXVINB(NF,MA,$IX,$JAG)
  $SUBST('UYTA$(CONSTR)D')
  $SUBST('UUB$(UPDATE)M1')
$L=$75 ; $LABEL
  IF(IDIR.EQ.0) THEN
  IF(ITERH.NE.0) CALL UYRES1('UPDATE  ')
  $IF(CONSTR='C') $SUBST('UYADS0')
  GOTO $20
  ELSE
  GOTO $30
  ENDIF
$L=$ 90 ; $LABEL
  IF(ITERM.LT.0) TXFU=TDXX
  CALL UYEPI1(1)
  $IF(NAL>0)
    $JOB=-1
    $IF(NORMA>0) $SUBST('UANRL3')
  $ENDIF
  $SUBST('UO1FU2')
  $ADD(INIT)
    NXFU='U1FBU1'
  $ENDADD
  $EXIT
