$INTERFACE U1FLU3                                             99/12/01
$REM LU
  $N='NF'
  $XM='XM'
  $XR='XR'
  $HR='HR'
  $GR='GR'
  $SR='SR'
  $HELP
    NUMBER OF BFGS CORRECTIONS
  $CHECK(MF,10,INT,2,NO)
  $ADD(INIT)
    MF=$MF
  $ENDADD
  $ADD(INTEGER,'\IMD')
  $ADD(REAL,'\$XM($NF*$MF)\$S($NF)')
  $ADD(REAL,'\SIG\GAM')
  $HERF='L'
$REM  $IF(CONSTR='S') $CONSTR='U'
  $IF(CONSTR='S')
    $CONSTR='C'
    $ADD(REAL,'\UXUDOT')
  $ELSE
    $ADD(REAL,'\UXVDOT')
  $ENDIF
  $TYPE='L'
  $HELP
    MATRIX DECOMPOSITION
      R - RECURSIVE QR DECOMPOSITION WITHOUT PERMUTATIONS
      I - INVERSION
  $CHECK(DECOMP,'R','R\I',2,NO)
  $HELP
    METHOD
      1 - METHOD OF REDUCED HESSIANS
      2 - METHOD OF ORTHOGONAL TRANSFORMATIONS
  $CHECK(NUMBER,1,'1\2',2,NO)
  $IF(DECOMP='I')
    $IF(NUMBER=2) $MOS=2
    $HELP
      TYPE OF INVERSION
        1 - INVERSION OF REDUCED HESSIAN MATRIX IS USED
        2 - REDUCED INVERSION OF HESSIAN MATRIX IS USED
    $CHECK(MOS,1,'1\2',3)
  $ENDIF
  $HELP
    DELETION OF COLUMNS OR RESTART
      0 - DELETION OF COLUMNS
      1 - RESTART
  $CHECK(MOT1,0,'0\1',3)
  $IF(NUMBER=1)
    $ADD(REAL,'\$XR(($MF+1)*($MF+2)/2)\$HR(($MF+1)*($MF+2)/2)&
    \$GR($MF+1)\$SR($MF+1)\$XO($MF+1)\$GO($MF+1)')
  $ELSE
    $HELP
      USE OF ORTHOGONAL TRANSFORMATIONS
        1 - UPDATE AFTER ORTHOGONAL TRANSFORMATIONS
        2 - UPDATE BEFORE ORTHOGONAL TRANSFORMATIONS
        3 - ORTHOGONAL TRANSFORMATIONS SUPPRESSED
    $CHECK(MOS1,1,'1\2\3',3)
    $ADD(REAL,'\$XR($MF*($MF+1)/2)\$HR($MF*($MF+1)/2)\$GR($MF)&
    \$SR($MF)\$XO($MF)\$GO($MF)')
    $ADD(INTEGER,'\IPOM')
  $ENDIF
  $HELP
    COMPUTATION OF THE PROJECTED GRADIENT NORM
      1 - DIFFERENCE OF TWO GRADIENT NORMS
      2 - PROJECTED GRADIENT NORM
  $CHECK(MOS2,1,'1\2',3)
  $ISNF=0
  $IF(TYPE='G')
    $HELP
      CHOICE OF THE VARIABLE METRIC UPDATE AFTER ZERO STEP:
        0 - NO UPDATE
        1 - NORMAL UPDATE
    $CHECK(MOT3,0,'0\1',4)
  $ELSE
    $HELP
      CHOICE OF THE INITIAL STEPSIZE:
        1-UNIT INITIAL STEPSIZE
        2-COMBINED UNIT AND QUADRATICALLY ESTIMATED INITIAL
          STEPSIZE FOR VM METHODS
        3-COMBINED UNIT AND QUADRATICALLY ESTIMATED INITIAL
          STEPSIZE FOR CG METHODS
        4-QUADRATICALLY ESTIMATED INITIAL STEPSIZE
    $CHECK(INITS,2,'1\2\3\4',4)
  $ENDIF
  $UPDATE='N'
  $HELP
    METHOD OF UPDATE OF HESSIAN MATRIX:
      1 - BFGS UPDATE
      2 - DFP UPDATE
      3 - HOSHINO UPDATE
      4 - SAFEGUARDED RANK ONE UPDATE
      5 - OPTIMALLY CONDITIONED UPDATE
      6 - SIMPLE PRECONVEX UPDATE
      7 - VARIATIONALLY DERIVED PRECONVEX UPDATE
      8 - NEW COMBINED UPDATE
      9 - PRECONVEX UPDATE DERIVED FROM MATRIX FACTORIZATION
     10 - ANGLE MINIMIZING UPDATE
  $CHECK(MET,1,'1\2\3\4\5\6\7\8\9\10',3)
$REM  $MET1=1
$REM  $MET2=1
$REM  $MET3=1
  $HELP
    SELECTION OF SELF SCALING:
      1 - SELF SCALING SUPPRESSED
      2 - INITIAL SELF SCALING
      3 - CONTROLLED SELF SCALING
      4 - SIMPLIFIED CONTROLLED SELF SCALING
      5 - SELF SCALING IN EACH ITERATION
  $CHECK(MET1,3,'1\2\3\4\5',4)
  $HELP
    SELECTION OF THE LINE SEARCH MODEL:
      1 - QUADRATIC MODEL
      2 - BASIC USE OF TAYLOR EXPANSION
      3 - MODIFIED USE OF TAYLOR EXPANSION
      4 - HOMOGENEOUS MODEL
      5 - CUBIC MODEL
  $CHECK(MET2,2,'1\2\3\4\5',4)
  $DEFAULT=1
  $IF(MET1=1) $DEFAULT=2
  $HELP
    METHOD OF REDUCED HESSIAN SCALING:
      1 - STANDARD SCALING
      2 - SIMPLIFIED SCALING
  $CHECK(MET5,DEFAULT,'1\2',3)
  $HELP
    CORRECTION OF APPROXIMATION OF HESSIAN MATRIX
    AFTER CHANGE OF BASIS:
      1 - RESTART
      2 - CORRECTION
  $CHECK(MLC,2,'1\2',3)
  $SUBST('UO0FU1')
  $SUBST('UZLIND')
  $IF(NAL>0)
    $MAL='$NAL'
    $ADD(INIT)
      MAL=NAL
    $ENDADD
    $JOB=1
    $IF(NORMA>0) $SUBST('UANRL3')
  $ENDIF
  $IF(CONSTR='C') $SUBST('UYFPC1')
  IF (ITERM.NE.0) GOTO $90
*
*     -----------------------------
*     SPARSE VARIABLE METRIC METHOD
*     TEMPLATE : U1FLU3
*     -----------------------------
*
  $LMD=$10
  ASSIGN $20 TO IMD
  CALL UYPRO1('UXFU',1)
  CALL UYPRO2(FMIN,FO)
$L=$10 ; $LABEL
  $KD=1
  $SUBST('UZMODL')
  $IF(KDS<1)
  $ELSEIF(CONSTR='C')
    IF(TSS(NS).EQ.'USXX') P=UXUDOT(NF,$G,$S,$IX,KBF)
  $ELSE
    IF(TSS(NS).EQ.'USXX') P=UXVDOT(NF,$G,$S)
  $ENDIF
  GO TO IMD
$L=$ 20 ; $LABEL
  $SUBST('UYTR$(CONSTR)G')
  $SUBST('UO2FU3')
  $SUBST('UYFUT1')
  IF (ITERM.NE.0) GOTO $90
  $IF(CONSTR='C')
    IF (RMAX.GT.ZERO) THEN
    $SUBST('UYRM$(CONSTR)0')
    ENDIF
  $ENDIF
$L=$ 30 ; $LABEL
  IF (IREST.GT.0) THEN
  SIG=ONE
  GAM=ONE
  TUXX='UNIT    '
  CALL UYSET3
  ENDIF
  IF (ITERM.NE.0) GOTO $90
  $IF(KDF=0)
    $IF(MCG<>0)
      $IF(MCG1=1)
        $SUBST('UYCP$(CON)S')
      $ENDIF
    $ENDIF
  $ENDIF
  $DEC=DECOMP
  $DECOMG=DEC
  $IF(DECOMG<>'I') $DECOMG='G'
  $MAT='R'
*
*     -----------------------
*     DIRECTION DETERMINATION
*     TEMPLATE : UD$(MAT)$(TYPE)$(DECOMG)1
*     -----------------------
*
  $SUBST('UD$(MAT)$(TYPE)$(DECOMG)1')
*
*     ------------------------------
*     END OF DIRECTION DETERMINATION
*     ------------------------------
*
  $SUBST('UD1T$(TYPE)2')
  IF (ITERM.NE.0) GOTO $90
  IF (IREST.NE.0) GOTO $30
$L=$ 60 ; $LABEL
  $SUBST('UYTR$(CONSTR)S')
  $IF(CONSTR='C')
    IF (RMAX.EQ.ZERO) GO TO $75
  $ENDIF
$L=$ 70 ; $LABEL
  ASSIGN $70 TO IMD
  $SUBST('UZLINS')
  GOTO ($74,$72) ISB+1
$L=$ 72 ; $LABEL
  $IF(CONSTR='C')
    CALL UXUDIR(NF,R,$S,$XO,$X,$IX,KBF)
    $SUBST('UCBS04')
  $ELSE
    CALL UXVDIR(NF,R,$S,$XO,$X)
  $ENDIF
  GOTO $10
$L=$ 74 ; $LABEL
  IF (ITERS.LE.0) THEN
  $IF(KDS<1)
    $SUBST('UYZER0')
  $ELSE
    $SUBST('UYZER1')
  $ENDIF
  IF(IDIR.EQ.0) THEN
  CALL UYRES1(TSXX)
  CALL UYSET1
  GO TO $30
  ELSE IF (MOT3.EQ.0) THEN
  CALL UYSET1
  GO TO $30
  ELSE
  ITERD=0
  ENDIF
  ENDIF
  IF(KD.GT.LD) THEN
  ASSIGN $80 TO IMD
  GO TO $10
  ENDIF
$L=$ 80 ; $LABEL
  TXFU=TUXX
  $IF(KDF=0)
    $IF(MCG<>0)
      $IF(MCG1=1)
        $SUBST('UYUP$(CON)D')
      $ENDIF
    $ENDIF
  $ENDIF
  $IF(NUMBER=1)
    $SUBST('UYTLUD')
  $ELSE
    IF (NN.LT.MF) THEN
    IPOM=1
    $SUBST('UYTLUD')
    ELSE
    IPOM=2
    $SUBST('UYTHUD')
    ENDIF
  $ENDIF
  $HS=H
  $H=XR
  $NS=N
  $N='NN'
  $NFS=NF
  $NF=MF
  $IF(NUMBER=1) $NF='$MF+1'
  $SUBST('UUDB$(DECOMG)1')
  $H=HS
  $N=NS
  $NF=NFS
  $IF(MET5=1)
    $IF(DECOMP='R')
      SIG=SIG/SQRT(GAM)
    $ELSE
      SIG=SIG*GAM
    $ENDIF
  $ENDIF
  $IF(NUMBER=1)
    $SUBST('UYTLUT')
  $ELSE
    $IF(MOS1=2)
      IF (IPOM.EQ.2) THEN
      $SUBST('UYTHUT')
      ENDIF
    $ENDIF
  $ENDIF
$L=$75 ; $LABEL
  IF(IDIR.EQ.0) THEN
  IF(ITERH.NE.0) CALL UYRES1('UPDATE  ')
  $IF(CONSTR='C') $SUBST('UYADC0')
  GOTO $20
  ELSE
  GOTO $30
  ENDIF
$L=$ 90 ; $LABEL
  IF(ITERM.LT.0) TXFU=TDXX
  CALL UYEPI1(1)
  $IF(NAL>0)
    $JOB=-1
    $IF(NORMA>0) $SUBST('UANRL3')
  $ENDIF
  $SUBST('UO1FU2')
  $ADD(INIT)
    NXFU='U1FLU3'
  $ENDADD
  $EXIT
