$INTERFACE U1FLU6                                             99/12/01
$REM LU
  $N='NF'
  $XM='XM'
  $HELP
    RANK OF THE PRODUCT FORM MATRIX
  $CHECK(MF,10,INT,2,NO)
  $ADD(INIT)
    MF=$MF
  $ENDADD
  $HELP
    PARAMETER ETA FOR STARTING UPDATES
  $CHECK(ETA3,'1.0$P 0',REAL,4)
  $HELP
    PARAMETER ETA FOR PROJECTION UPDATES
  $CHECK(ETA4,'1.0$P 0',REAL,4)
  $CON1='2.5$P-1'
  $ADD(INTEGER,'\IMD')
  $ADD(REAL,'\$XM($NF*$MF)')
  $HERF='L'
  $IF(CONSTR='S') $CONSTR='C'
  $IF(CONSTR='C')
    $POM1='U'
    $POM2=',$$IX,KBF)'
  $ELSE
    $POM1='V'
    $POM2=')'
  $ENDIF
  $ADD(REAL,'\UX$(POM1)DOT')
  $TYPE='L'
  $DECOMP='I'
  $NUMBER=1
  $ISNF=0
  $IF(TYPE='G')
    $HELP
      CHOICE OF THE VARIABLE METRIC UPDATE AFTER ZERO STEP:
        0 - NO UPDATE
        1 - NORMAL UPDATE
    $CHECK(MOT3,0,'0\1',4)
  $ELSE
    $HELP
      TOLERANCE FOR DESCENT DIRECTION
    $CHECK(EPS0,'1.0$P-8',REAL,4)
    $HELP
      CHOICE OF THE INITIAL STEPSIZE:
        1-UNIT INITIAL STEPSIZE
        2-COMBINED UNIT AND QUADRATICALLY ESTIMATED INITIAL
          STEPSIZE FOR VM METHODS
        3-COMBINED UNIT AND QUADRATICALLY ESTIMATED INITIAL
          STEPSIZE FOR CG METHODS
        4-QUADRATICALLY ESTIMATED INITIAL STEPSIZE
    $CHECK(INITS,2,'1\2\3\4',4)
  $ENDIF
  $UPDATE='V'
  $HELP
    CORRECTION OF APPROXIMATION OF HESSIAN MATRIX
    AFTER CHANGE OF BASIS:
      1 - RESTART
      2 - CORRECTION
  $CHECK(MLC,2,'1\2',3)
  $SUBST('UO0FU1')
  $SUBST('UZLIND')
  $IF(NAL>0)
    $MAL='$NAL'
    $ADD(INIT)
      MAL=NAL
    $ENDADD
    $JOB=1
    $IF(NORMA>0) $SUBST('UANRL3')
  $ENDIF
  $IF(CONSTR='C') $SUBST('UYFPC1')
  IF (ITERM.NE.0) GOTO $90
*
*     -----------------------------
*     SPARSE VARIABLE METRIC METHOD
*     TEMPLATE : U1FLU6
*     -----------------------------
*
  $LMD=$10
  ASSIGN $20 TO IMD
  CALL UYPRO1('UXFU',1)
  CALL UYPRO2(FMIN,FO)
  NN=0
  PAR=ZERO
$L=$10 ; $LABEL
  $KD=1
  $SUBST('UZMODL')
  $IF(KDS<1)
  $ELSE
  IF(TSS(NS).EQ.'USXX') P=UX$(POM1)DOT(NF,$G,$S$POM2
  $ENDIF
  GO TO IMD
$L=$20 ; $LABEL
  $SUBST('UYTR$(CONSTR)G')
  $SUBST('UO2FU3')
  $SUBST('UYFUT1')
  IF (ITERM.NE.0) GOTO $90
  $IF(CONSTR='C')
    IF (RMAX.GT.ZERO) THEN
    $SUBST('UYRM$(CONSTR)0')
    ENDIF
  $ENDIF
$L=$30 ; $LABEL
$REM  $SUBST('UULSD1')
  IF (IREST.GT.0) THEN
  IF (PAR.GT.ZERO.AND.NN.GT.0) THEN
  PAR=SQRT(PAR)
  ELSE
  PAR=ONE
  ENDIF
  POM=ONE
  NN=0
  TUXX='UNIT    '
  LD=MIN(LD,1)
  CALL UYSET3
  ENDIF
  IF (ITERM.NE.0) GOTO $90
  $IF(KDF=0)
    $IF(MCG<>0)
      $IF(MCG1=1)
        $SUBST('UYCP$(CON)S')
      $ENDIF
    $ENDIF
  $ENDIF
  $MAT='P'
*
*     -----------------------
*     DIRECTION DETERMINATION
*     TEMPLATE : UD$(MAT)$(TYPE)$(DECOMP)3
*     -----------------------
*
  $SUBST('UD$(MAT)$(TYPE)$(DECOMP)3')
*
*     ------------------------------
*     END OF DIRECTION DETERMINATION
*     ------------------------------
*
  $SUBST('UD1T$(TYPE)2')
  IF (ITERM.NE.0) GOTO $90
  IF (IREST.NE.0) GOTO $30
$L=$60 ; $LABEL
  $SUBST('UYTR$(CONSTR)S')
  $IF(CONSTR='C')
    IF (RMAX.EQ.ZERO) GO TO $75
  $ENDIF
$L=$70 ; $LABEL
  ASSIGN $70 TO IMD
  $SUBST('UZLINS')
  GOTO ($74,$72) ISB+1
$L=$72 ; $LABEL
  CALL UX$(POM1)DIR(NF,R,$S,$XO,$X$POM2
  $IF(CONSTR='C') $SUBST('UCBS04')
  GOTO $10
$L=$74 ; $LABEL
  IF (ITERS.LE.0) THEN
  $IF(KDS<1)
    $SUBST('UYZER0')
  $ELSE
    $SUBST('UYZER1')
  $ENDIF
  IF(IDIR.EQ.0) THEN
  CALL UYRES1(TSXX)
  CALL UYSET1
  GO TO $30
  ELSE IF (MOT3.EQ.0) THEN
  CALL UYSET1
  GO TO $30
  ELSE
  ITERD=0
  ENDIF
  ENDIF
  IF(KD.GT.LD) THEN
  ASSIGN $80 TO IMD
  GO TO $10
  ENDIF
$L=$80 ; $LABEL
  TXFU=TUXX
  $IF(KDF=0)
    $IF(MCG<>0)
      $IF(MCG1=1)
        $SUBST('UYUP$(CON)D')
      $ENDIF
    $ENDIF
  $ENDIF
  CALL UXVNEG(NF,$GO,$S)
  $SUBST('UYTR$(CONSTR)D')
  IF (NN.LT.MF) THEN
  RHO=ONE
  POM=0.8$P 0
  $SUBST('UULSP5')
  ELSE
  $SUBST('UULVP5')
  ENDIF
$L=$75 ; $LABEL
  IF(IDIR.EQ.0) THEN
  IF(ITERH.NE.0) CALL UYRES1('UPDATE  ')
  $IF(CONSTR='C') $SUBST('UYADC0')
  GOTO $20
  ELSE
  GOTO $30
  ENDIF
$L=$90 ; $LABEL
  IF(ITERM.LT.0) TXFU=TDXX
  CALL UYEPI1(1)
  $IF(NAL>0)
    $JOB=-1
    $IF(NORMA>0) $SUBST('UANRL3')
  $ENDIF
  $SUBST('UO1FU2')
  $ADD(INIT)
    NXFU='U1FLU6'
  $ENDADD
  $EXIT
