$INTERFACE UDDGQ2                                             97/12/01
$REM LU
  $SO='SO'
  $ADD(REAL,'\$AG($NA*$NF)\$H($NF*($NF+1)/2)\$GN($NF)\$SN($NF)\$XO($NF)&
  \$GO($NF)\$XS($NF)\$SO($NF)\$AF($NA)\$AFO($NA)')
  $ADD(REAL,'\ALF\BET\RHO\RHO1\RHO2\RHO3')
  $ADD(INTEGER,'\NOS')
  $ADD(REAL,'\UXVDOT')
  $ADD(REAL,'\UXVDEL')
  $HELP
    NUMBER OF DOG-LEG STEPS
  $CHECK(MOS,3,INT,3)
  $HELP
    TYPE OF DOG-LEG STRATEGY
       1 - BASIC DOG-LEG STRATEGY
       2 - EXTENDED DOG-LEG STRATEGY
  $CHECK(MOS2,1,'1\2',3)
  $DEFAULT=2
  $IF(MOS=1) $DEFAULT=1
  $HELP
    LEVEL OF DECOMPOSITION SPARING
  $CHECK(MOS3,DEFAULT,'1\2\3',3)
  $HELP
    TOLERANCE FOR POSITIVE DEFINITENESS
  $CHECK(ETA2,'ETA0*1.0D-3',REAL,4)
  $HELP
    MAXIMUM STEPSIZE
  $CHECK(XDEL,'0.0$P 0',REAL,3)
  $HELP
    LOWER BOUND FOR GRADIENT
  $CHECK(TOLG,'1.0$P-8',REAL,3)
  $N='N'
  CALL UOD1D1
  IF (IDECA.LT.0) IDECA=1
  IF (IDECA.EQ.0) THEN
  $IF(MOS3=0)
*
*     QR DECOMPOSITION
*
    RHO1=ETA2
    CALL UXDRQF($N,NA,$AG,$H)
    CALL UXDPRC($N,$H,INF,RHO1)
    NDECF=NDECF+1
    IDECA=1
  $ENDIF
  ELSE IF (IDECA.EQ.1) THEN
  ELSE
  ITERD=-1
  TDXX='BAD DEC1'
  CALL UOERR1('UDDGQ2',1)
  GO TO $50
  ENDIF
  IF (LD.LE.0) THEN
  CALL UXDCMM($N,NA,$AG,$AF,$GN)
  CALL UXVNEG($N,$GN,$SO)
  IF (IDECA.EQ.1) CALL UXDPRM($N,$H,$GN,-1)
  ELSE IF (IPOM1.EQ.1) THEN
  CALL UXVNEG($N,$GN,$SO)
  IF (IDECA.EQ.1) CALL UXDPRB($N,$H,$SO,1)
  ELSE
  CALL UXDCMM($N,NA,$AG,$AF,$SO)
  CALL UXVNEG($N,$SO,$SO)
  ENDIF
  CALL UXVCOP($N,$GN,$GO)
  GNORM=SQRT(UXVDOT($N,$GO,$GO))
  IF (KD.LE.0) THEN
  IF (GNORM.LE.TOLG) THEN
  ITERM=4
  TXFU='GRAD TOL'
  GO TO $50
  ENDIF
  ENDIF
  INITD=MAX(ABS(INITD),1)
  IF (XDEL.LE.ZERO) THEN
*
*     INITIAL TRUST REGION BOUND
*
  IF (IDECA.NE.1) THEN
  CALL UXDRMM($N,NA,$AG,$GO,$AFO)
  RHO1=UXVDOT(NA,$AFO,$AFO)
  ELSE
  CALL UXVCOP($N,$GO,$SN)
  CALL UXDPRM($N,$H,$SN,1)
  RHO1=UXVDOT($N,$SN,$SN)
  ENDIF
  RHO2=GNORM*GNORM
  IF (RHO1.LE.ZERO) THEN
  XDEL=GNORM
  ELSE
  XDEL=(RHO2/RHO1)*GNORM
  ENDIF
  IF(IEST.EQ.1) XDEL=MIN(XDEL,FOUR*(F-FMIN)/GNORM)
  XDEL=MIN(XDEL,XMAX)
  ENDIF
  IF (IDECA.EQ.1) THEN
  CALL UXDPRB($N,$H,$SO,-1)
  RHO3=SQRT(UXVDOT($N,$SO,$SO))
  IF (RHO3.LE.XDEL) THEN
*
*     NEWTON DIRECTION IS ACCEPTED
*
  CALL UXVCOP($N,$SO,$SN)
  SNORM=RHO3
  ITERD=1
  TDXX='DOG STEP'
  GO TO $40
  ENDIF
  ENDIF
  SNORM = ZERO
  CALL UXVSET($N,ZERO,$SN)
  CALL UXVNEG($N,$GO,$XS)
  CALL UXVNEG($N,$GO,$XO)
  RHO1=UXVDOT($N,$XS,$XS)
  RHO=RHO1
  NOS=MIN(MOS,N)
  DO $10 NRED=1,NOS
  IF (IDECA.NE.1) THEN
  CALL UXDRMM($N,NA,$AG,$XO,$AFO)
  CALL UXDCMM($N,NA,$AG,$AFO,$GO)
  ELSE
  CALL UXVCOP($N,$XO,$GO)
  CALL UXDPRM($N,$H,$GO,0)
  ENDIF
  ALF=UXVDOT($N,$XO,$GO)
  IF (ALF.LE.ZERO) THEN
*
*     INDEFINITE CASE
*
  RHO1=UXVDOT($N,$XO,$SN)
  RHO2=UXVDOT($N,$XO,$XO)
  CALL UNSTEP(XDEL,SNORM,RHO1,RHO2,ALF)
  CALL UXVDIR($N,ALF,$XO,$SN,$SN)
  SNORM=XDEL
  ITERD=3
  TDXX='CG  MAX1'
  GO TO $40
  ENDIF
  ALF=RHO/ALF
  RHO2=SQRT(UXVDEL($N,ALF,$XO,$SN))
  IF (RHO2.GE.XDEL) THEN
*
*     TRUST REGION BOUND
*
  RHO1=UXVDOT($N,$XO,$SN)
  CALL UXVDIR($N,ALF,$XO,$SN,$SO)
  RHO3=SQRT(UXVDOT($N,$SO,$SO))
  $IF(MOS2=1)
    TDXX='CG  MAX2'
  $ELSE
    TDXX='CG  MAX3'
  $ENDIF
  GO TO $60
  ENDIF
*
*     CG STEP
*
  CALL UXVDIR($N,ALF,$XO,$SN,$SN)
  CALL UXVDIR($N,-ALF,$GO,$XS,$XS)
  SNORM=RHO2
  RHO2=UXVDOT($N,$XS,$XS)
  CALL UOD1D4(RHO1,RHO2,ALF,SNORM,XDEL)
  IF (RHO2.LE.ETA0*RHO1) THEN
*
*     CG SOLUTION
*
  $IF(MOS3<3)
    GO TO $20
  $ENDIF
  ITERD=1
  TDXX='CG  STEP'
  GO TO $40
  ENDIF
  ALF=RHO2/RHO
  CALL UXVDIR($N,ALF,$XO,$XS,$XO)
  RHO=RHO2
$10 CONTINUE
$20 CONTINUE
  SNORM=SQRT(UXVDOT($N,$SN,$SN))
  $IF(MOS2=1)
    TDXX='DOG MAX1'
  $ELSE
    TDXX='DOG MAX2'
  $ENDIF
  IF (IDECA.EQ.0) THEN
*
*     QR DECOMPOSITION
*
  RHO1=ETA2
  CALL UXDRQF($N,NA,$AG,$H)
  CALL UXDPRC($N,$H,INF,RHO1)
  NDECF=NDECF+1
  IDECA=1
  CALL UXDPRB($N,$H,$SO,0)
  RHO3=SQRT(UXVDOT($N,$SO,$SO))
  IF (RHO3.LE.XDEL) THEN
*
*     NEWTON DIRECTION IS ACCEPTED
*
  CALL UXVCOP($N,$SO,$SN)
  SNORM=RHO3
  ITERD=1
  TDXX='DOG STEP'
  GO TO $40
  ENDIF
  ENDIF
*
*     EXTENDED DOG-LEG STRATEGY
*
$60 CONTINUE
  $IF(MOS2>1)
    RHO=UXVDOT($N,$GN,$SO)
    IF (RHO.NE.ZERO) THEN
    RHO=UXVDOT($N,$GN,$SN)/RHO
    ELSE
    RHO=ONE
    ENDIF
  $ELSE
    RHO=ONE
  $ENDIF
*
*     BOUNDARY STEP IS COMPUTED
*
$30 CONTINUE
  RHO2=UXVDOT($N,$SN,$SO)
  CALL UNDOG1(XDEL,SNORM,RHO2,RHO3,RHO,ALF,BET,$MOS2)
  CALL UXVLIN($N,ALF,$SO,BET,$SN,$SN)
  SNORM=XDEL
  ITERD=3
  CALL UOD1D4(RHO1,RHO2,ALF,SNORM,XDEL)
$40 CONTINUE
  IF (IDECA.NE.1) THEN
  CALL UXDRMM($N,NA,$AG,$SN,$AFO)
  PP=UXVDOT(NA,$AFO,$AFO)*HALF
  ELSE
  CALL UXVCOP($N,$SN,$GO)
  CALL UXDPRM($N,$H,$GO,1)
  PP=UXVDOT($N,$GO,$GO)*HALF
  ENDIF
$50 CONTINUE
  CALL UOD1D2($N,$GN,$SN)
  $ADD(INIT)
    NDXX='UDDGQ2'
  $ENDADD
  $EXIT
