$INTERFACE UDSGA7                                             05/12/01
$REM LU
  $C1L='0.1$P 0'
  $C1U='0.9$P 0'
  $CON1='1.0$P-8'
$REM  $POM1='U'
$REM  $POM2=',$$IX,-KBF)'
  $POM1='V'
  $POM2=')'
  $DEFAULT='ETA0*1.0$P-3'
  $HELP
    TOLERANCE FOR POSITIVE DEFINITENESS
  $CHECK(ETA2,DEFAULT,REAL,4)
  $HELP
    LOWER PRECISION FOR OPTIMUM LOCALLY CONSTRAINED STEP
  $CHECK(DEL1,'0.9$P 0',REAL,4)
  $HELP
    UPPER PRECISION FOR OPTIMUM LOCALLY CONSTRAINED STEP
  $CHECK(DEL2,'1.1$P 0',REAL,4)
  $HELP
    MAXIMUM STEPSIZE
  $CHECK(XDEL,'0.0$P 0',REAL,3)
  $ADD(REAL,'\$H($MMAX)\$G($NF)\$S($NF)\$GO($NF)')
  $ADD(REAL,'\UXVDOT\UX$(POM1)DOT\UXSPCP\UXSSDL\UXSSMQ')
  $ADD(REAL,'\ALF\RHO\RHO1\RHO2\CON')
  $ADD(INTEGER,'\I\K\L\MM')
  CALL UOD1D1
  GNORM=SQRT(UXVDOT(NF,$G,$G))
  $SUBST('UDSL$(DECOMD)I')
  IF (IDECF.NE.0.AND.IDECF.NE.1) THEN
  ITERD=-1
  TDXX='BAD DEC1'
  CALL UOERR1('UDSGA7',1)
  GO TO $90
  ENDIF
  INITD=MAX(ABS(INITD),1)
  MM=$IH(NF+1)-1
  IF (XDEL.LE.ZERO) THEN
*
*     INITIAL TRUST REGION BOUND
*
  RHO1=UXSSMQ(NF,MM,$H,$IH,$JH,$G,$G)
  RHO2=GNORM*GNORM
  IF (RHO1.LE.ZERO) THEN
  XDEL=GNORM
  ELSE
  XDEL=(RHO2/RHO1)*GNORM
  ENDIF
$REM  IF (IEST.EQ.1) XDEL=MIN(XDEL,FOUR*(FF-FMIN)/GNORM)
  XDEL=MIN(XDEL,XMAX)
  ENDIF
*
*     INITIAL BOUNDS FOR THE PARAMETER T
*
  NRED=0
  IF (IDIR.LE.0) THEN
  T=ZERO
  E=-UXSSDL(NF,MMAX,$H,$IH,$JH,INF)
  CALL UXSSMG(NF,MMAX,$H,$IH,$JH,EL,EU,$S)
  TL=GNORM/XDEL-EU
  TU=GNORM/XDEL-EL
  ELSE IF (IDIR.EQ.1) THEN
  T=T*XDELO/XDEL
  TL=MAX(TL,GNORM/XDEL-EU)
  TU=GNORM/XDEL-EL
  ELSE IF (IDIR.EQ.2) THEN
  T=T*XDELO/XDEL
  TL=GNORM/XDEL-EU
  TU=MIN(TU,GNORM/XDEL-EL)
  ENDIF
  TL=MAX(TL,ZERO,E)
  TU=MAX(TL,TU)
  T=MAX(T,TL)
  T=MIN(T,TU)
  TDXX='INITIAL '
$20 CONTINUE
  TL=MAX(TL,E)
  IF (T.LE.E.AND.NRED.NE.0) THEN
*
*     THE PARAMETER T IS SHIFTED
*
  T=SQRT(TL*TU)
  T=MAX(T,TL+$C1L*(TU-TL))
  T=MIN(T,TL+$C1U*(TU-TL))
  TDXX='SHIFTED '
  ENDIF
  ALF=ETA2
  CALL UXSPCT($N,MM,MH,MMAX,$H,$JH,$PSL,ITERM)
  IF (ITERM.NE.0) THEN
  TDXX='LACK SPC'
  GO TO $90
  ENDIF
*
*     SPARSE GILL-MURRAY DECOMPOSITION
*
  CALL UXSPCA($N,MM,MH,MMAX,$H,$IH,$JH,T)
  CALL UXSPCF($N,MMAX-MM,$H(MM+1),$PSL,$JH(MM+1),$WN11,$WN12,$GO,INF&
,ALF,RHO)
  NDECF=NDECF+1
  IF (INF.GT.0) THEN
*
*     NEW ESTIMATION E IS COMPUTED (THE MATRIX IS NOT POSITIVE DEFINITE)
*
  IF (E.GE.TU) THEN
  ITERD=-2
  TDXX='ZERO INT'
  CALL UOERR1('UDSGA7',2)
  GO TO $90
  ELSE
  MODE=2
  CALL UOD1D3(T,TL,TU,E,SNORM,XDEL,MODE)
  CALL UXSPCD(NF,MMAX-MM,$H(MM+1),$PSL,$JH(MM+1),$S,INF)
  CALL UXVSBP(NF,$PERM,$S,$GO)
  E=MAX(E,T-ALF/UXVDOT(NF,$S,$S))
  NRED=NRED+1
  GO TO $20
  ENDIF
  ELSE
*
*     STEP S IS COMPUTED
*
  CALL UXVNEG(NF,$G,$S)
  CALL UXVSFP(NF,$PERM,$S,$GO)
  CALL UXSPCB(NF,MMAX-MM,$H(MM+1),PSL,JH(MM+1),$S,0)
  CALL UXVSBP(NF,$PERM,$S,$GO)
  SNORM=SQRT(UXVDOT(NF,$S,$S))
  MODE=1
  CALL UOD1D3(T,TL,TU,E,SNORM,XDEL,MODE)
  ENDIF
  IF (TU-TL.LE.$CON1) THEN
*
*     INTERVAL IS TOO SMALL
*
  IF (T.NE.ZERO) THEN
  ITERD=5
  TDXX='ZERO INT'
  ELSE
  ITERD=1
  TDXX='OLC STEP'
  ENDIF
  GO TO $80
  ELSE IF (NRED.GE.20) THEN
*
*     MAXIMUM NUMBER OF OLC REDUCTIONS
*
  ITERD=6
  TDXX='MAX NRED'
  GO TO $80
  ELSE IF (SNORM.GT.DEL2*XDEL) THEN
*
*     STEP IS TOO LARGE
*
  TL=MAX(TL,T)
  GO TO $30
  ELSE IF (SNORM.LT.DEL1*XDEL) THEN
  IF (T.NE.ZERO) THEN
*
*     STEP IS TOO SMAL
*
  TU=MIN(TU,T)
  ELSE
*
*     STEP IS ACCEPTABLE
*
  ITERD=1
  TDXX='OLC STEP'
  GO TO $80
  ENDIF
  ELSE
  ITERD=3
  TDXX='OLC MAX1'
  GO TO $80
  ENDIF
*
*     TRYING TO USE BOUNDARY STEP
*
  CALL UXSPCN(NF,MMAX-MM,$H(MM+1),$PSL,$JH(MM+1),$XO,RHO,1)
  CALL UXVSBP(NF,$PERM,$XO,$GO)
  RHO1=UXVDOT(NF,$XO,$S)
  RHO2=UXVDOT(NF,$XO,$XO)
  CALL UNSTEP(XDEL,SNORM,ABS(RHO1),RHO2,ALF)
  CON=(ONE-DEL1)*(ONE+DEL1)
  IF (ALF*ALF*RHO.LE.CON*(T*XDEL*XDEL-UXVDOT(NF,$G,$S))) THEN
  IF (RHO1.LT.ZERO) ALF=-ALF
  CALL UXVDIR(NF,ALF,$XO,$S,$S)
  SNORM=XDEL
  ITERD=3
  TDXX='OLC MAX2'
  GO TO $80
  ELSE
  E=MAX(E,T-RHO)
  ENDIF
$30 CONTINUE
  IF (GNORM.LE.ZERO) THEN
  T=E
  ELSE
*
*     NEW T IS COMPUTED USING ONE STEP OF THE NEWTON METHOD FOR
*     NONLINEAR EQUATION
*
  CALL UXVCOP(NF,$S,$XO)
  CALL UXVSFP(NF,$PERM,$XO,$GO)
  CALL UXSPCB(NF,MMAX-MM,$H(MM+1),$PSL,$JH(MM+1),$XO,1)
  T=T+(SNORM*SNORM/UXSPCP(NF,MMAX-MM,$H(MM+1),$PSL,$XO))*(SNORM-XDEL)&
/XDEL
  CALL UXVSBP($N,$PERM,$XO,$GO)
  TDXX='NEWTON  '
  ENDIF
  NRED=NRED+1
  GO TO $20
$REM  CALL UODLX4(NF,NA,$X,$G,$S,$GO,FF,RPF3,INF)
$80 CONTINUE
  PP=UXSSMQ(NF,MMAX,$H,$IH,$JH,$S,$S)*HALF
$90 CONTINUE
  CALL UOD1D2(NF,$G,$S)
  $ADD(INIT)
    NDXX='UDSGA7'
  $ENDADD
  $EXIT
