$INTERFACE UDSGX1                                             16/12/01
$REM LU
  $CON0='1.0$P-8'
  $GS='GS'
  $GP='GP'
$REM  $POM1='U'
$REM  $POM2=',$$IX,-KBF)'
  $POM1='V'
  $POM2=')'
  $HELP
    METHOD SELECTION:
      1 - SINGLE  DOG-LEG STRATEGY
      2 - DOUBLE  DOG-LEG STRATEGY
  $CHECK(MOS,2,'1\2',3)
  $DEFAULT='ETA0*1.0$P-3'
  $HELP
    TOLERANCE FOR POSITIVE DEFINITENESS
  $CHECK(ETA2,DEFAULT,REAL,4)
  $HELP
    UPPER BOUND FOR STEPSIZE PARAMETER
  $CHECK(ALF2,'1.0$P 6',REAL,4)
  $HELP
    MAXIMUM STEPSIZE
  $CHECK(XDEL,'0.0$P 0',REAL,3)
  $ADD(REAL,'\$H($MMAX)\$G($NF+1)\$S($NF+1)\$XO($NF+1)\$GO($NF+1)&
  \$GS($NF+1)\$GP($NF+1)')
  $ADD(REAL,'\$X($NF+1)\$AZL($NA)\$AZU($NA)')
  $ADD(INTEGER,'\$IAG($NA+1)\$JAG($MA)')
  $IF(HESF='S')
  $ADD(INTEGER,'\$IH($NF+2)\$JH($MMAX)')
  $ENDIF
  $ADD(REAL,'\UXVDOT\UX$(POM1)DOT')
  $IF(HESF='S')
    $ADD(REAL,'\UXSSMQ')
    $IF(DEC='G')
      $ADD(REAL,'\UXSPCQ')
    $ENDIF
  $ELSEIF(HESF='D')
    $ADD(REAL,'\UXDSMQ')
    $IF(DEC='G')
      $ADD(REAL,'\UXDPGQ')
    $ELSE
      $HELP
         TYPE OF DECOMPOSITION
           1 - BUNCH-PARLETT DECOMPOSITION WITH NUMERICAL PERMUTATIONS
           2 - BUNCH-KAUFMAN DECOMPOSITION WITH NUMERICAL PERMUTATIONS
           3 - BUNCH PARLETT DECOMPOSITION WITH TWO LEVEL INDICES
      $CHECK(MOS2,1,'1\2\3',2)
      $IF(MOS2<3)
        $LET='L'
        $ART=',MOS2)'
        $ADD(REAL,'\UXDLBQ')
      $ELSE
        $LET=S
        $ART=')'
        $ADD(REAL,'\UXDSBQ')
      $ENDIF
    $ENDIF
  $ENDIF
  $ADD(REAL,'\ALF\BET\RHO\B1\B2\B3')
  $ADD(INTEGER,'\I\J\JP\K\L\MM')
  $IF(DEC='G')
    $IDECF=1
  $ELSEIF(DEC='B')
    $HS='HS'
    $ADD(REAL,'\$HS($M)')
    $IDECF=3
  $ENDIF
  CALL UOD1D1
  B2=UXVDOT(NF,$G,$G)
  GNORM=SQRT(B2)
  $IF(HESF='D')
    IF (IDIR.GT.0) THEN
    CALL UXDSMC(NF,$H,$HH)
    IDECF=0
    ENDIF
  $ENDIF
  $SUBST('UDSLXI')
  INITD=MAX(ABS(INITD),1)
  $IF(HESF='S')
    MM=$IH(NF+1)-1
    $IF(DEC='G')
      IF (IDECF.EQ.0) THEN
      B1=UXSSMQ(NF,MMAX,$H,$IH,$JH,$G,$G)
      ELSE
      CALL UXVCOP(NF,$G,$GO)
      CALL UXVSFP(NF,$PERM,$GO,$XO)
      CALL UXSPCM(NF,MMAX-MM,$H(MM+1),$PSL,$JH(MM+1),$GO,$XO,1)
      B1=UXSPCQ(NF,MMAX-MM,$H(MM+1),$PSL,$GO)
      ENDIF
    $ELSEIF(DEC='B')
      B1=UXSSMQ(NF,MMAX,$H,$IH,$JH,$G,$G)
    $ENDIF
  $ELSEIF(HESF='D')
    $IF(DEC='G')
      IF (IDECF.EQ.0) THEN
      B1=UXDSMQ(NF,$HH,$G,$G)
      ELSE
      CALL UXVCOP(NF,$G,$GO)
      CALL UXDPGM(NF,$HH,$GO,1)
      B1=UXDPGQ(NF,$HH,$GO,$GO)
      ENDIF
    $ELSEIF(DEC='B')
      IF (IDECF.EQ.0) THEN
      B1=UXDSMQ(NF,$HH,$G,$G)
      ELSE
      CALL UXVCOP(NF,$G,$GO)
      CALL UXD$(LET)BM(NF,$HH,$IH,$GO,1)
      B1=UXD$(LET)BQ(NF,$HH,$IH,$GO,$GO)
    $ENDIF
  $ENDIF
  IF (XDEL.LE.ZERO) THEN
*
*     INITIAL TRUST REGION BOUND
*
  IF (B1.LE.ZERO) THEN
  XDEL=GNORM
  ELSE
  XDEL=(B2/B1)*GNORM
  ENDIF
$REM  IF (IEST.EQ.1) XDEL=MIN(XDEL,FOUR*(FF-FMIN)/GNORM)
  XDEL=MIN(XDEL,XMAX)
  ENDIF
  IF (B1.LE.ZERO.OR.B2*GNORM.GE.B1*XDEL) THEN
*
*     SCALED STEEPEST DESCENT DIRECTION IS ACCEPTED
*
  CALL UXVSCL(NF,-XDEL/GNORM,$G,$S)
  SNORM=XDEL
  ITERD=3
  TDXX='SD  MAX '
  GO TO $90
  ENDIF
  IF (IDECF.EQ.0) THEN
  $IF(HESF='S')
    $IF(DEC='G')
      CALL UXSPCT(NF,MM,MH,MMAX,$H,$JH,$PSL,ITERM)
      IF (ITERM.NE.0) THEN
      TDXX='LACK SPC'
      GO TO $90
      ENDIF
*
*     SPARSE GILL-MURRAY DECOMPOSITION
*
      RHO=ETA2
      CALL UXSPCF(NF,MMAX-MM,$H(MM+1),$PSL,$JH(MM+1),$WN11,$WN12,$XO,INF&
,RHO,ALF)
      IDECF=1
    $ELSEIF(DEC='B')
*
*     SPARSE BUNCH-PARLETT DECOMPOSITION
*
      CALL UXVCOP($IH(NF+1)-1,$H,$HS)
      CALL UXSIBF(NF,MM,$KH,$JH,$HS,MMAX,$IW,MMAX,$IW1,$IW2,NAU,NUP&
,ITERM)
      IF (ITERM.LT.0) THEN
      TXFU='LACK SPC'
      GO TO $90
      ENDIF
      IDECF=3
    $ENDIF
  $ELSEIF(HESF='D')
    $IF(DEC='G')
      RHO=ETA2
      CALL UXDPGF(NF,$HH,INF,RHO,TAU)
      IDECF=1
    $ELSEIF(DEC='B')
      RHO=ETA2
      CALL UXD$(LET)BF(NF,$HH,$IH,INF,RHO,MOS2)
      IDECF=3
    $ENDIF
  $ENDIF
  NDECF=NDECF+1
  ENDIF
*
*     COMPUTATION OF THE NEWTON DIRECTION
*
  $IF(HESF='S')
    $IF(DEC='G')
      CALL UXVCOP(NF,$GS,$GP)
      CALL UXVSFP(NF,$PERM,$GP,$XO)
      CALL UXSPCB(NF,MMAX-MM,$H(MM+1),$PSL,$JH(MM+1),$GP,0)
      CALL UXVSBP(NF,$PERM,$GP,$XO)
      CALL UXVNEG(NF,$G,$GO)
      CALL UXVSFP(NF,$PERM,$GO,$XO)
      CALL UXSPCB(NF,MMAX-MM,$H(MM+1),$PSL,$JH(MM+1),$GO,0)
      CALL UXVSBP(NF,$PERM,$GO,$XO)
    $ELSEIF(DEC='B')
      CALL UXVCOP(NF,$GS,$GP)
      CALL UXSIBB(NF,$HS,MMAX,$IW,MMAX,$XO,$GP,$IW1,NAU,NUP)
      CALL UXVNEG(NF,$G,$GO)
      CALL UXSIBB(NF,$HS,MMAX,$IW,MMAX,$XO,$GO,$IW1,NAU,NUP)
    $ENDIF
  $ELSE
    $IF(DEC='G')
      CALL UXVCOP(NF,$GS,$GP)
      CALL UXDPGB(NF,$HH,$GP,0)
      CALL UXVNEG(NF,$G,$GO)
      CALL UXDPGB(NF,$HH,$GO,0)
    $ELSEIF(DEC='B')
      CALL UXVCOP(NF,$GS,$GP)
      CALL UXD$(LET)BB(NF,$HH,$IH,$GP,0)
      CALL UXVNEG(NF,$G,$GO)
      $IF(MOS2<3)
        CALL UXDLBB(NF,$HH,$IH,$GO,0)
      $ELSE
        CALL UXDSBB(NF,$HH,$IH,$GO,0)
      $ENDIF
    $ENDIF
  $ENDIF
  IF (UXVDOT(NF,$GS,$GP)-$GS(NF+1).EQ.ZERO) THEN
  $GO(NF+1)=ZERO
  ELSE
  $GO(NF+1)=-(UXVDOT(NF,$GS,$GO)-G(NF+1))/(UXVDOT(NF,$GS,$GP)-$GS(NF+1))
  CALL UXVDIR(NF,$GO(NF+1),$GP,$GO,$GO)
  ENDIF
  RHO=SQRT(UXVDOT(NF,$GO,$GO))
*
*     COMPUTATION OF THE STEEPEST DESCENT DIRECTION
*
  B2=B2/B1
  SNORM=B2*GNORM
  CALL UXVSCL(NF,-B2,$G,$S)
  CALL UXVDIF(NF,$GO,$S,$XO)
  B1=UXVDOT(NF,$S,$XO)
  B2=UXVDOT(NF,$XO,$XO)
  IF (B2.LE.$CON0*XDEL*XDEL) THEN
*
*     NEWTON AND THE STEEPEST DESCENT DIRECTION ARE
*     APPROXIMATELY EQUAL
*
  CALL UXVCOP(NF,$GO,$S)
  SNORM=RHO
  ITERD=1
  TDXX='DOG STEP'
  ELSE IF (B1.LE.ZERO) THEN
*
*     BOUNDARY STEP WITH NEGATIVE INCREMENT
*
  CALL UNSTEP(XDEL,SNORM,-B1,B2,B3)
  CALL UXVDIR(NF,-B3,$XO,$S,$S)
  SNORM=XDEL
  ITERD=3
  TDXX='DOG NEG '
  ELSE IF (RHO.LE.XDEL) THEN
*
*     NEWTON DIRECTION IS ACCEPTED
*
  CALL UXVCOP(NF,$GO,$S)
  SNORM=RHO
  ITERD=1
  TDXX='DOG STEP'
  ELSE
  $IF(MOS=1)
*
*     SINGLE DOGLEG STRATEGY
*
    CALL UNSTEP(XDEL,SNORM,B1,B2,B3)
    CALL UXVDIR(NF,B3,$XO,$S,$S)
    SNORM=XDEL
    ITERD=3
    TDXX='DOG MAX1'
  $ELSE
*
*     DOUBLE DOGLEG STRATEGY
*
    RHO=XDEL/RHO
    B3=UXVDOT(NF,$S,$GO)
    RHO=MAX(RHO,SNORM*SNORM/B3)
    CALL UXVDIR(NF,-RHO,$GO,$S,$XO)
    B1=SNORM*SNORM-RHO*B3
    B2=UXVDOT(NF,$XO,$XO)
    CALL UNSTEP(XDEL,SNORM,-B1,B2,B3)
    CALL UXVDIR(NF,-B3,$XO,$S,$S)
    SNORM=XDEL
    ITERD=3
    TDXX='DOG MAX2'
  $ENDIF
  ENDIF
  CALL UODLX4(NF,NA,$X,$G,$S,$GO,FF,RPF3,INF)
$90 CONTINUE
  $IF(HESF='S')
    $IF(DEC='G')
      IF (IDECF.EQ.0) THEN
      PP=UXSSMQ(NF,MMAX,$H,$IH,$JH,$S,$S)*HALF
      ELSE
      CALL UXVCOP(NF,$S,$GO)
      CALL UXVSFP(NF,$PERM,$GO,$XO)
      CALL UXSPCM(NF,MMAX-MM,$H(MM+1),$PSL,$JH(MM+1),$GO,$XO,1)
      PP=UXSPCQ(NF,MMAX-MM,$H(MM+1),$PSL,$GO)*HALF
      IF (ITERD.EQ.1.AND.INF.NE.0) ITERD=2
      ENDIF
    $ELSEIF(DEC='B')
      PP=UXSSMQ(NF,MMAX,$H,$IH,$JH,$S,$S)*HALF
    $ENDIF
  $ELSE
    $IF(DEC='G')
      IF (IDECF.EQ.0) THEN
      PP=UXDSMQ(NF,$HH,$S,$S)*HALF
      ELSE
      CALL UXVCOP(NF,$S,$GO)
      CALL UXDPGM(NF,$HH,$GO,1)
      PP=UXDPGQ(NF,$HH,$GO,$GO)*HALF
      ENDIF
    $ELSEIF(DEC='B')
      IF (IDECF.EQ.0) THEN
      PP=UXDSMQ(NF,$HH,$S,$S)*HALF
      ELSE
      CALL UXVCOP(NF,$S,$GO)
      CALL UXD$(LET)BM(NF,$HH,$IH,$GO,1)
      PP=UXD$(LET)BQ(NF,$HH,$IH,$GO,$GO)*HALF
    $ENDIF
  $ENDIF
  CALL UOD1D2(NF,$G,$S)
  $ADD(INIT)
    NDXX='UDSGX1'
  $ENDADD
  $EXIT
