$INTERFACE UDVLC3                                             97/12/01
$REM LU
  $IF(CONSTR='C')
    $POM1='U'
    $POM2=',$$IX,KBF)'
  $ADD(INTEGER,'\$IX($NF)')
  $ELSE
    $POM1='V'
    $POM2=')'
  $ENDIF
  $IF($DEF(KDS))
  $ELSE
    $DEFAULT=0
    $IF(KDF>0) $DEFAULT=1
    $IF(KDA>0) $DEFAULT=1
    $IF(KDE>0) $DEFAULT=1
    $IF(KDY>0) $DEFAULT=1
    $IF(DEFAULT=1)
      $HELP
        DEGREE OF DIRECTIONAL DERIVATIVES IN LINE SEARCH:
          0 - NO DIRECTIONAL DERIVATIVES
          1 - FIRST DIRECTIONAL DERIVATIVES
      $CHECK(KDS,$DEFAULT,'0\1',4,NO)
    $ELSE
      $KDS=0
    $ENDIF
  $ENDIF
  $DEFAULT=4
  $IF(KDS=0) $DEFAULT=2
  $HELP
    TERMINATION CRITERION:
      1-PERFECT LINE SEARCH
      2-GOLDSTEIN STEPSIZE
      3-WEAK WOLFE STEPSIZE
      4-STRONG WOLFE STEPSIZE
      5-ARMIJO STEPSIZE
  $CHECK(KTERS,DEFAULT,'1\2\3\4\5',4)
  $DEFAULT=1
  $HELP
    RESTART SPECIFICATION. RESTART IS PERFORMED AFTER
    IRES1*N+IRES2 ITERATIONS.
  $CHECK(IRES1,DEFAULT,INT,4)
  $DEFAULT=0
  $HELP
    RESTART SPECIFICATION. RESTART IS PERFORMED AFTER
    IRES1*N+IRES2 ITERATIONS.
  $CHECK(IRES2,DEFAULT,INT,4)
  $DEFAULT='1.0$P-4'
  $IF(KDS=0) $DEFAULT='4.0$P-1'
  $HELP
    TERMINATION TOLERANCE FOR LINE SEARCH
    (IN TEST ON THE CHANGE OF THE FUNCTION VALUE)
  $CHECK(EPS1,DEFAULT,REAL,4)
  $HELP
    TERMINATION TOLERANCE FOR LINE SEARCH
    (IN TEST ON THE CHANGE OF THE DIRECTIONAL DERIVATES)
  $CHECK(EPS2,'1.0$P-1',REAL,4)
  $HELP
    INITIAL STEPSIZE IN THE FIRST STEP
  $CHECK(XDEL,'5.0$P-1',REAL,4)
  $ADD(REAL,'\$GN($NF)\$SN($NF)\$XO($NF)\$GO($NF)\$SO($NF)')
  $ADD(REAL,'\UX$(POM1)DOT\UX$(POM1)NOR')
  $ADD(REAL,'\ALF\BET\GAM\DEL\DEN\POM\TMP')
  CALL UOD0D1(R,GNORM)
  ALF=GNORM*GNORM
  BET=UX$(POM1)DOT($N,$GN,$GN$POM2
  GNORM=SQRT(BET)
  INITD=MAX(ABS(INITD),1)
  IF (IREST.NE.0) THEN
  TUXX='INITIAL '
  GO TO $10
  ENDIF
  CALL UX$(POM1)DIR($N,-UX$(POM1)DOT($N,$GN,$SO$POM2,$SO,$GN,$SO)
  CALL UXVSCL($N,-ONE/UX$(POM1)NOR($N,$SO$POM2,$SO,$SO)
  CALL UX$(POM1)COP($N,$SN,$XO$POM2
  BET=UX$(POM1)DOT($N,$GO,$SO$POM2/UX$(POM1)DOT($N,$GO,$XO$POM2
  CALL UX$(POM1)DIR($N,BET,$XO,$SO,$SN$POM2
  CALL UXVSCL($N,-ONE/UX$(POM1)NOR($N,$SN$POM2,$SN,$SN)
  ALF=DEL*UX$(POM1)DOT($N,$GN,$XO$POM2/UX$(POM1)DOT($N,$GO,$XO$POM2
  DEL=(DEL+ALF)*BET/SQRT(ONE-BET**2)
  CALL UX$(POM1)DIR($N,ALF,$XO,$X,$X)
  CALL UX$(POM1)DIR($N,DEL,$SN,$X,$X)
  GO TO $20
$10 ITERD=0
*
*     STEEPEST DESCENT DIRECTION
*
  DEL=XDEL
  CALL UX$(POM1)COP($N,$GN,$SO$POM2
  CALL UXVSCL($N,-ONE/UX$(POM1)NOR($N,$SO$POM2,$SO,$SO)
  CALL UX$(POM1)COP($N,$SO,$SN$POM2
  CALL UX$(POM1)DIR($N,DEL,$SN,$X,$X)
  TDXX='ST.DESC.'
  CALL UYSET3
$20 CONTINUE
  CALL UOD1D2($N,$GN,$SN)
  $ADD(INIT)
    NDXX='UDVLC3'
  $ENDADD
  $EXIT
