$REM +---------------------------------------------------------------+
$REM + TEMPLATE: UGFU31                                    01/12/01  +
$REM + SI                                                            +
$REM + PURPOSE: GLOBAL OPTIMIZATION  - DENSITY CLUSTERING METHOD     +
$REM +---------------------------------------------------------------+
      $HELP
        MAX. NUMBER OF POINTS IN THE RANDOM SAMPLE (IN ONE STEP)
      $CHECK(MNRND,'100+20*$NF',STR,3,NO)
      $HELP
        MAX. NUMBER OF LOCAL MINIMA
      $CHECK(MNLMIN,'50+10*$NF',STR,3,NO)
      $HELP
        REDUCTION OF RANDOM SAMPLE (TYPICALLY: 0.1 .. 0.2)
      $CHECK(GAMA,'0.1$(P)0',REAL,3,NO)
      $HELP
        PARAMETER OF CLUSTER TERMINATION (TYPICALLY: 2 .. 8)
      $CHECK(SIGMA,4,INT,3,NO)
      $SUBST('UZSRND')
      $ADD(REAL,'\X($NF)\XL($NF)\XU($NF)')
      $TEXT='UGFU31'
      $SUBST('UO3FU1')
$L=$00; $LABEL
      CALL UGFU31(NF,X,XL,XU,F)
      GOTO ($30,$10,$20) ISB+1
$L=$20; $LABEL
      $SUBST('UZLMIN')
      GOTO $00
$L=$10; $LABEL
      $KD=0
      $SUBST('UZMODL')
      GOTO $00
$L=$30; $LABEL
$ADD(SUBROUTINES)
      SUBROUTINE UGFU31(NF,X,XL,XU,F)
      INTEGER NF
      $FLOAT X($NF),XL($NF),XU($NF),F
      $INCLUDE('UMCOMM')
      REAL UNRAN$RGTYPE
      $FLOAT FRS($MNRND),XRS($NF*($MNRND)),FSET($MNLMIN),
     &       XSET($NF*($MNLMIN)),FSEED,XSEED($NF),CLRAD,GAMA,UYGCR2,
     &       UXVNM2
      INTEGER NRND,NRRND,NRNDT,MNRND,NLMIN,MNLMIN,NCLUST,INDX($MNRND),
     &       UYGSSZ,UYGSST,I,J,K,NITT,NFVT,NFGT,NFHT,NLMST,IDUM
      LOGICAL ADDCL,UYGST1,UYDMIN
      SAVE FRS,XRS,FSET,XSET,FSEED,XSEED,CLRAD,GAMA
      SAVE NRND,NRRND,NRNDT,MNRND,NLMIN,MNLMIN,NCLUST,INDX,
     & NITT,NFVT,NFGT,NFHT,NLMST,I,J
$REM      IF (NS.EQ.0.OR.TSS(NS).NE.'UGFX') THEN
      IF (NS.EQ.0) THEN
        CALL UYPRO1('UGFX',-1)
        NITT=0
        NFVT=0
        NFGT=0
        NFHT=0
        IDUM=-1
        NLMST=0
        MNRND=$MNRND
        MNLMIN=$MNLMIN
        GAMA=$GAMA
        X(1)=UNRAN$RGTYPE(IDUM)
        NRND=UYGSST(NF)
        IF (NRND.GT.MNRND) NRND=MNRND
        NRNDT=NRND
        NLMIN=0
      ENDIF
      GOTO (1,30,70), ISP(NS)
    1 CONTINUE
  *
  *     RANDOM SAMPLE
  *
      J=1
   10 CONTINUE
        IDUM=1
        DO 20 I=1,NF
          X(I)=(XU(I)-XL(I))*UNRAN$RGTYPE(IDUM)+XL(I)
   20   CONTINUE
        CALL UXVCOP(NF,X,XRS((J-1)*NF+1))
  *
  *     COMPUTATION OF THE FUNCTION VALUE
  *
        KD=0
        CALL UYSET2
        CALL UYSET0(1,2)
        RETURN
   30   CONTINUE
        FRS(J)=F
        NFVT=NFVT+1
        J=J+1
      IF (J.LE.NRND) GOTO 10
  *
  *     CREATE INDEX TABLE
  *
      CALL UYINDX(NRND,FRS,INDX)
  *
  *     REDUCED SAMPLE
  *
      NRRND=NRND*GAMA
      J=1
      NCLUST=NRRND
  *
  *     DETERMINE SEED POINTS
  *
   40 IF (NCLUST.LE.0) GOTO 120
  *
  *     ARE ALL REDUCED SAMPLE POINTS ASSIGNED TO A CLUSTER ?
  *
      IF (J.LE.NLMIN) GOTO 90
  *
  *     FIND NEW MINIMA
  *
      NCLUST=NCLUST-1
      K=1
   60 IF(INDX(K).EQ.0) THEN
        K=K+1
        GOTO 60
      ENDIF
      CALL UXVCOP(NF,XRS((INDX(K)-1)*NF+1),X)
      INDX(K)=0
  *
  *     LOCAL OPTIMIZATION
  *
      CALL UYCLST
      CALL UYSET0(2,3)
      RETURN
   70 CONTINUE
      NITT=NITT+NIT
      NFVT=NFVT+NFV
      NFGT=NFGT+NFG
      NFHT=NFHT+NFH
      NLMST=NLMST+1
      K=1
   80 CONTINUE
      IF (K.LE.NLMIN) THEN
        IF (UYDMIN(NF,F,X,FSET(K),XSET((K-1)*NF+1))) THEN
          K=K+1
          GOTO 80
        ENDIF
      ENDIF
      IF (K.GT.NLMIN.AND.ITERM.GE.1.AND.ITERM.LE.10) THEN
        NLMIN=NLMIN+1
        CALL UXVCOP(NF,X,XSET((NLMIN-1)*NF+1))
        FSET(NLMIN)=F
        CALL UO3FU4(NITT,NFVT,NLMIN,F)
        IF(NLMIN.GE.MNLMIN) GOTO 130
      ENDIF
      GOTO 40
  *
  *     J-TH LOCAL MINIMUM IS THE NEXT SEED POINT
  *
   90 CALL UXVCOP(NF,XSET((J-1)*NF+1),XSEED)
      FSEED=FSET(J)
  *
  *     FORM CLUSTER
  *
      I=1
  100 CONTINUE
  *
  *     NEW CLUSTER RADIUS
  *
      CLRAD=UYGCR2(NF,NRNDT,I,$SIGMA,XL,XU)
      ADDCL=.FALSE.
      K=1
  110 IF (K.LE.NRRND) THEN
        IF (INDX(K).GT.0) THEN
          IF(FSEED.LE.FRS(INDX(K)).AND.
   &         UXVNM2(NF,XSEED,XRS((INDX(K)-1)*NF+1)).LE.CLRAD) THEN
            INDX(K)=0
            NCLUST=NCLUST-1
            ADDCL=.TRUE.
          ENDIF
        ENDIF
        K=K+1
        GOTO 110
      ENDIF
      IF (ADDCL) THEN
        I=I+1
        GOTO 100
      ELSE
        J=J+1
        GOTO 40
      ENDIF
  *
  *     STOP IT ?
  *
  120 IF (.NOT.UYGST1(NLMIN,INT(GAMA*NRNDT))) THEN
  *
  *     NEW RANDOM SAMPLE SIZE
  *
        NRND=UYGSSZ(NLMIN,GAMA)
        IF (NRND.GT.MNRND) NRND=MNRND
        NRNDT=NRNDT+NRND
        GOTO 10
      ENDIF
  *
  *     PRINT OF RESULTS
  *
  130 CALL UYINDX(NLMIN,FSET,INDX)
      F=FSET(INDX(1))
      CALL UXVCOP(NF,XSET((INDX(1)-1)*NF+1),X)
      NIT=NITT
      NFV=NFVT
      NFG=NFGT
      NFH=NFHT
      CALL UO3FU5(NF,NLMIN,MNLMIN,FSET,XSET,INDX)
      CALL UYEPI1(-1)
      END
$ENDADD
