$REM +---------------------------------------------------------------+
$REM + TEMPLATE: UGFU43                                    01/12/01  +
$REM + SI                                                            +
$REM + PURPOSE: GLOBAL OPTIMIZATION  - MODIFIED MULTI LEVEL          +
$REM +                                 SINGLE LINKAGE                +
$REM +---------------------------------------------------------------+
$REM TADY CHYBI MCALEEC
      $HELP
        MAX. NUMBER OF POINTS IN THE RANDOM SAMPLE (IN ONE STEP)
      $CHECK(MNRND,'20*$NF+100',STR,3,NO)
      $HELP
        MAX. NUMBER OF LOCAL MINIMA
      $CHECK(MNLMIN,'20*$NF+50',STR,3,NO)
      $HELP
        REDUCTION OF RANDOM SAMPLE (TYPICALLY: 0.1 .. 0.2)
      $CHECK(GAMA,'0.15$(P)0',REAL,3,NO)
      $HELP
        PARAMETER OF SINGLE LINKAGE
      $CHECK(SIGMA,3,INT,3,NO)
      $SUBST('UZSRND')
      $ADD(REAL,'\X($NF)\XL($NF)\XU($NF)')
      $TEXT='UGFU43'
      $SUBST('UO3FU1')
$L=$00; $LABEL
      CALL UGFU43(NF,X,XL,XU,F)
      GOTO ($30,$10,$20) ISB+1
$L=$20; $LABEL
      $SUBST('UZLMIN')
      GOTO $00
$L=$10; $LABEL
      $KD=0
      $SUBST('UZMODL')
      GOTO $00
$L=$30; $LABEL
$ADD(SUBROUTINES)
      SUBROUTINE UGFU43(NF,X,XL,XU,F)
      INTEGER NF
      $FLOAT X($NF),XL($NF),XU($NF),F
      $INCLUDE('UMCOMM')
      REAL UNRAN$RGTYPE
      $FLOAT FRS($MNRND),XRS($NF*($MNRND)),FSET($MNLMIN),
     &       XSET($NF*($MNLMIN)),FLINK,XLINK($NF),CLRAD,GAMA,UYGCR1,
     &       UXVNM2
      INTEGER NRND,NRRND,NRNDT,MNRND,NLMIN,MNLMIN,INDX($MNRND),
     &       UYGSSZ,I,J,K,NITT,NFVT,NFGT,NFHT,NLMST,IDUM
      LOGICAL UYGST1,UYDMIN,LINKED
      SAVE FRS,XRS,FSET,XSET,FLINK,XLINK,CLRAD,GAMA
      SAVE NRND,NRRND,NRNDT,MNRND,NLMIN,MNLMIN,INDX,
     & NITT,NFVT,NFGT,NFHT,NLMST,I,J
$REM      IF (NS.EQ.0.OR.TSS(NS).NE.'UGFX') THEN
      IF (NS.EQ.0) THEN
        CALL UYPRO1('UGFX',-1)
        NITT=0
        NFVT=0
        NFGT=0
        NFHT=0
        IDUM=-1
        NLMST=0
        MNRND=$MNRND
        MNLMIN=$MNLMIN
        GAMA=$GAMA
        X(1)=UNRAN$RGTYPE(IDUM)
        NRND=NF*25
        IF (NRND.GT.MNRND) NRND=MNRND
        NRNDT=NRND
        NLMIN=0
      ENDIF
      GOTO (10,40,80), ISP(NS)
   10 CONTINUE
  *
  *     RANDOM SAMPLE
  *
      J=1
   20 CONTINUE
        IDUM=1
        DO 30 I=1,NF
          X(I)=(XU(I)-XL(I))*UNRAN$RGTYPE(IDUM)+XL(I)
   30   CONTINUE
        CALL UXVCOP(NF,X,XRS((J-1)*NF+1))
  *
  *     COMPUTATION OF THE FUNCTION VALUE
  *
        KD=0
        CALL UYSET2
        CALL UYSET0(1,2)
        RETURN
   40   CONTINUE
        FRS(J)=F
        NFVT=NFVT+1
        J=J+1
      IF (J.LE.NRND) GOTO 20
  *
  *     CREATE INDEX TABLE
  *
      CALL UYINDX(NRND,FRS,INDX)
  *
  *     REDUCED SAMPLE
  *
      NRRND=NRND*GAMA
  *
  *     FORM CLUSTERS
  *
      CLRAD=UYGCR1(NF,NRNDT,$SIGMA,XL,XU)
      J=0
  *
  *     MULTI LEVEL SINGLE LINKAGE - MAIN LOOP
  *
   50 IF (J.GE.NRRND) GOTO 100
      J=J+1
      LINKED=.FALSE.
      FLINK=FRS(INDX(J))
      CALL UXVCOP(NF,XRS((INDX(J)-1)*NF+1),XLINK)
  *
  *     LINKED TO EXTREM ?
  *
      K=1
   60 IF (.NOT.LINKED.AND.K.LE.NLMIN) THEN
        IF (FLINK.GE.FSET(K).AND.
   &        UXVNM2(NF,XSET((K-1)*NF+1),XLINK).LE.CLRAD) THEN
          LINKED=.TRUE.
        ENDIF
        K=K+1
        GOTO 60
      ENDIF
  *
  *     LINKED TO POINT WITH LOWER FUNCTION VALUE ?
  *
      K=1
   70 IF (.NOT.LINKED.AND.K.LT.J) THEN
        IF (FLINK.GE.FRS(INDX(K)).AND.
   &      UXVNM2(NF,XRS((INDX(K)-1)*NF+1),XLINK).LE.CLRAD) THEN
          LINKED=.TRUE.
        ENDIF
        K=K+1
        GOTO 70
      ENDIF
      IF (LINKED) GOTO 50
      CALL UXVCOP(NF,XRS((INDX(J)-1)*NF+1),X)
  *
  *     LOCAL OPTIMIZATION
  *
      CALL UYCLST
      CALL UYSET0(2,3)
      RETURN
   80 CONTINUE
      NITT=NITT+NIT
      NFVT=NFVT+NFV
      NFGT=NFGT+NFG
      NFHT=NFHT+NFH
      NLMST=NLMST+1
      K=1
   90 CONTINUE
      IF (K.LE.NLMIN) THEN
        IF (UYDMIN(NF,F,X,FSET(K),XSET((K-1)*NF+1))) THEN
          K=K+1
          GOTO 90
        ENDIF
      ENDIF
      IF (K.GT.NLMIN.AND.ITERM.GE.1.AND.ITERM.LE.10) THEN
        NLMIN=NLMIN+1
        CALL UXVCOP(NF,X,XSET((NLMIN-1)*NF+1))
        FSET(NLMIN)=F
        CALL UO3FU4(NITT,NFVT,NLMIN,F)
        IF (NLMIN.GE.MNLMIN) GOTO 110
      ENDIF
      GOTO 50
  *
  *     STOP IT ?
  *
  100 IF (.NOT.UYGST1(NLMIN,INT(GAMA*NRNDT))) THEN
  *
  *     NEW RANDOM SAMPLE SIZE
  *
        NRND=UYGSSZ(NLMIN,GAMA)
        IF (NRND.GT.MNRND) NRND=MNRND
        NRNDT=NRNDT+NRND
        GOTO 10
      ENDIF
  *
  *     PRINT OF RESULTS
  *
  110 CALL UYINDX(NLMIN,FSET,INDX)
      F=FSET(INDX(1))
      CALL UXVCOP(NF,XSET((INDX(1)-1)*NF+1),X)
      NIT=NITT
      NFV=NFVT
      NFG=NFGT
      NFH=NFHT
      CALL UO3FU5(NF,NLMIN,MNLMIN,FSET,XSET,INDX)
      CALL UYEPI1(-1)
      END
$ENDADD
